//myString.h

#include<cstring>
#include<iostream>
#include<string>

using namespace std;

class String
{
	char* charArr;
	int size;
public:
	String();
	String(const char* ch);
	~String();
	String(const String& str);

	bool check(int i) const;
	char operator[](int i) const;
	void write(int k, char ch);
	int getSize();

	String& operator=(const String& str);
	String& operator+(String& str);
	String& operator+=(String& str);
	bool operator==(String& str);
	bool operator!=(String& str);
	bool operator<(String& str);
	bool operator>(String& str);
	bool operator<=(String& str);
	bool operator>=(String& str);

	friend ostream& operator<<(ostream&, String&);
	friend istream& operator>>(istream&, String&);
};
