//oop_ex126.cpp
//Function Templates in C++

#include <iostream>

using namespace std;

struct test
{
	int a;
};


void printArray(const int* arr, const int count)
{
	cout << "void printArray(const int* arr, const int count)" << endl;
	for (int i = 0; i<count; i++)
		cout << arr[i] << " ";
	cout << endl;
}


//template<typename T>
template<class T>
void printArray(const T* arr, const int count)
{
	for (int i = 0; i<count; i++)
		cout << arr[i] << " ";
	cout << endl;
}


void main()
{
	const int icount = 9;
	int iarr[icount] = { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
	printArray(iarr, icount);

	const int ccount = 5;
	char carr[icount] = "test";
	printArray(carr, ccount);

	const int dcount = 5;
	double darr[dcount] = { 0.1, 0.2, 0.3, 0.4, 0.5 };
	printArray(darr, dcount);


	const int tcount = 5;
	test tarr[dcount];
	//printArray(tarr, tcount);		//<< op is not defined by test

	system("pause");
}